<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="80px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="name" label="团队名称">
                <el-input v-model="formData.name"></el-input>
            </el-form-item>
            <el-form-item prop="userId" label="管理人员">
                <div class="subform">
                    <el-select
                        v-model="formData.userId"
                        style="width: 360px"
                        filterable
                        clearable
                        @change="chooseAdmin"
                    >
                        <el-option v-for="item in users" :key="item.id" :value="item.id" :label="item.nickname">
                            <span style="float: left">{{ item.nickname }}</span>
                            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.phone }}</span>
                        </el-option>
                    </el-select>
                </div>
            </el-form-item>
            <el-form-item prop="emps" label="员工">
                <div class="subform">
                    <el-select v-model="emps" style="width: 360px" filterable clearable multiple>
                        <el-option v-for="item in users" :key="item.id" :value="item.id" :label="item.nickname">
                            <span style="float: left">{{ item.nickname }}</span>
                            <span style="float: right; color: #8492a6; font-size: 13px">{{ item.phone }}</span>
                        </el-option>
                    </el-select>
                </div>
            </el-form-item>
            <!--<el-form-item prop="amount" label="团队余额">
                <el-input-number type="number" v-model="formData.amount"></el-input-number>
            </el-form-item>-->
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除</el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'CompanyEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('company/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
            this.$http
                .post('user/user', { companyId: this.$route.query.id })
                .then(res => {
                    this.users = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        } else {
            this.$http
                .post('user/user')
                .then(res => {
                    this.users = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
    },
    data() {
        return {
            saving: false,
            formData: {
                userId: ''
            },
            rules: {},
            users: [],
            emps: []
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };
            data.emplyee = this.emps;

            this.saving = true;
            this.$http
                .post('/company/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/company/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error(e.error);
                    }
                });
        },
        chooseAdmin(id) {
            this.user = this.users.find(item => {
                return item.id === id;
            });
        }
    }
};
</script>
<style lang="less" scoped>
.subform {
    padding: 16px 16px 16px 16px;
    background: #f2f3f5;
    border-radius: 8px;
    border: 1px solid #eee;
    margin-bottom: 10px;
}
</style>
